#include <clidef>
#include <cliservdef>
#include <descrip>

typedef struct dsc$descriptor string;

#define SLEN(a)   (a).dsc$w_length
#define STYPE(a)  (a).dsc$b_dtype
#define SCLASS(a) (a).dsc$b_class
#define SADDR(a)  (a).dsc$a_pointer

#define STRING(a,b) {(a).dsc$w_length = strlen(b); (a).dsc$a_pointer = (b);}

int set_symbol(char *symbol_name, char *symbol_value)
{
    static struct
    {
        unsigned char cli$b_rqtype;     /* request type */
        unsigned short cli$w_servcod;   /* service code */
        unsigned char cli$b_rqstat;     /* probably not correct, oh well..  */
        string cli$q_namdesc;           /* symbol name  */
        string cli$q_valdesc;           /* symbol value */
    } blk = {CLI$K_CLISERV, CLI$K_DEFGLOBAL, 0};

    STRING(blk.cli$q_namdesc, symbol_name);
    STRING(blk.cli$q_valdesc, symbol_value);

    return sys$cli(&blk);
}

main(int argc, char *argv[])
{
    int status;

    status = set_symbol("24",  "set term/page=24");
    if (!(status & 1)) lib$signal(status);

    /* etc. */
}

