(* ------------------------------------------------------------------------- *)
[inherit('sys$library:starlet','sys$library:pascal$lib_routines')]
program sys$cli_test(input,output);
const
  cli_k_verb_verb = 0;    (* Seemingly undefined *)
  cli_w_normal = 196608;  (* Another create-your-own constant *)
type
  $ubyte = [byte] 0..255;
  cli_type = record
    cli$b_rqtype  : [pos(0)] $ubyte;
    cli$b_rqindx  : [pos(8)] $ubyte;
    cli$b_rqflags : [pos(16)] $ubyte;
    cli$b_rqstat  : [pos(24)] $ubyte;
    cli$_fill_1    : [pos(32)] array [1..4] of $ubyte;
    cli$q_rqdesc  : [pos(64)] dsc1$type;
  end;
  pstring = packed array [1..144] of char;
  var_ptr = [unsafe] ^pstring;
var
  c : cli_type;
  ss : unsigned;
  pstr : var_ptr;

[asynchronous,external]
function sys$cli(%ref cliblk : [unsafe] array [$l1..$u1:integer] of $ubyte):
integer; external;

begin

(* Print out the command line. *)

  c := zero;
  c.cli$b_rqtype := cli$k_getline;
  ss := sys$cli(c);
  if not odd(ss) then lib$signal(ss);
  write('The command line is: ');
  pstr := c.cli$q_rqdesc.dsc$a_pointer;
  writeln(substr(pstr^,1,c.cli$q_rqdesc.dsc$w_maxstrlen));

(* Determine how the image was invoked. *)

  c := zero;
  c.cli$b_rqtype := cli$k_getcmd;
  ss := sys$cli(c);
  if not odd(ss) and (ss <> cli_w_normal) then lib$signal(ss);
  write('The command buffer is: ');
  pstr := c.cli$q_rqdesc.dsc$a_pointer;
  writeln(substr(pstr^,1,c.cli$q_rqdesc.dsc$w_maxstrlen));
  write('The image was invoked by: ');
  case int(c.cli$b_rqstat) of
    cli_k_verb_verb : writeln('[VERB]');
    cli$k_verb_run  : writeln('[RUN]');
    cli$k_verb_mcr  : writeln('[MCR]');
    cli$k_verb_fore : writeln('[FOREIGN COMMAND]');
    otherwise writeln('[UNKNOWN - See $CLIVERBDEF for details]');
  end;

end.
(* ------------------------------------------------------------------------- *)
